"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DoubleCurveWithTimeCursor = exports.DoubleCurveWithTimestamp = exports.DoubleCurveWithDuration = exports.DoubleCurve = exports.SingleCurve = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _range = _interopRequireDefault(require("lodash/range"));

var _immutableTransformMatrix = _interopRequireDefault(require("immutable-transform-matrix"));

var _getMinorMajorDurationLines = _interopRequireDefault(require("../../utils/get-minor-major-duration-lines"));

var _ = _interopRequireDefault(require("./"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  title: "Wave",
  component: _.default,
  argTypes: {}
};
exports.default = _default;
var curve1 = {
  color: "#f00",
  data: (0, _range.default)(500).map(function (i) {
    return [i, Math.sin(i / 20) * 100];
  })
};
var curve2 = {
  color: "#00f",
  data: (0, _range.default)(500).map(function (i) {
    return [i, Math.cos(i / 40) * 100];
  })
};
var topLevelMatrix = new _immutableTransformMatrix.default().translate(0, 100);
var gridLineMetrics = (0, _getMinorMajorDurationLines.default)(topLevelMatrix, 500);

var SingleCurve = function SingleCurve() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    curves: [curve1],
    width: 500,
    height: 200,
    gridLineMetrics: gridLineMetrics,
    transformMatrix: new _immutableTransformMatrix.default().translate(0, 100)
  });
};

exports.SingleCurve = SingleCurve;

var DoubleCurve = function DoubleCurve() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    curves: [curve1, curve2],
    width: 500,
    height: 200,
    gridLineMetrics: gridLineMetrics,
    transformMatrix: new _immutableTransformMatrix.default().translate(0, 100)
  });
};

exports.DoubleCurve = DoubleCurve;

var DoubleCurveWithDuration = function DoubleCurveWithDuration() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    curves: [curve1, curve2],
    width: 500,
    height: 200,
    transformMatrix: new _immutableTransformMatrix.default().translate(0, 100),
    gridLineMetrics: gridLineMetrics,
    durationGroups: [{
      color: "#f00",
      durations: [{
        start: 100,
        end: 400
      }]
    }]
  });
};

exports.DoubleCurveWithDuration = DoubleCurveWithDuration;

var DoubleCurveWithTimestamp = function DoubleCurveWithTimestamp() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    curves: [curve1, curve2],
    width: 500,
    height: 200,
    transformMatrix: new _immutableTransformMatrix.default().translate(0, 100),
    gridLineMetrics: gridLineMetrics,
    timestamps: [{
      time: 250,
      color: "#f00"
    }]
  });
};

exports.DoubleCurveWithTimestamp = DoubleCurveWithTimestamp;

var DoubleCurveWithTimeCursor = function DoubleCurveWithTimeCursor() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    curves: [curve1, curve2],
    width: 500,
    height: 200,
    transformMatrix: new _immutableTransformMatrix.default().translate(0, 100),
    gridLineMetrics: gridLineMetrics,
    timeCursorTime: 250
  });
};

exports.DoubleCurveWithTimeCursor = DoubleCurveWithTimeCursor;